/*
Bellaciao: a Salut à Toi frontend
Copyright (C) 2011  Jérôme Poisson (goffi@goffi.org)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "bridge.h"

Bridge::Bridge(const QString &service, const QString &path, const QDBusConnection &connection, QObject *parent)
    : DBusBridgeFrontend(service, path, connection, parent)
{
    qDebug() << "Bridge initialisation";
}

Bridge* Bridge::_bridge_instance = 0;

Bridge* Bridge::getBridge()
{
    if (_bridge_instance == 0) {
        qDBusRegisterMetaType<StringDict>();
        qDBusRegisterMetaType<MenuT>();
        qDBusRegisterMetaType< QList<MenuT> >();
        qDBusRegisterMetaType<Contact>();
        qDBusRegisterMetaType< QList<Contact> >();

        _bridge_instance = new Bridge("org.goffi.SAT", "/org/goffi/SAT/bridge", QDBusConnection::sessionBus()); 
    }

    return _bridge_instance;
}
