/*
Bellaciao: a Salut à Toi frontend
Copyright (C) 2011  Jérôme Poisson (goffi@goffi.org)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef CONTACT_H
#define CONTACT_H

#include <QSharedData>
#include <QString>
#include <QHash>
#include <QList>
#include "jid.h"

class ContactData: public QSharedData
{
    public:
        ContactData();
        ContactData(const ContactData& other);
        
        Jid jid;
        QList<QString> groups;
        bool m_connected;
        bool m_presence_to, m_presence_from, m_presence_ask;
        QString m_profile, m_name;

        
};

class Contact {
    public:
        Contact();
        Contact(const Contact &other);
       
        Jid& getJid();
        const Jid& getJid() const;
        QList<QString>& getGroups();
        const QList<QString>& getGroups() const;
        void setProfile(const QString& profile);
        const QString& getProfile() const;
        void setAttributes(const QHash<QString, QString>& attr);
        QHash<QString, QString> getAttributes() const;
        const QString& getName() const;
        void setName(const QString& name);
        bool isConnected();

    private:
        QExplicitlySharedDataPointer<ContactData> d;
};


#endif
