/*
Bellaciao: a Salut à Toi frontend
Copyright (C) 2011  Jérôme Poisson (goffi@goffi.org)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "dbus_types.h"
#include <QtGlobal>

QDBusArgument &operator<<(QDBusArgument &argument, const Jid &jid)
{
    return argument << jid.getString();
}

const QDBusArgument &operator>>(const QDBusArgument &argument, Jid &jid)
{
    QString _str = QString();
    argument >> _str;
    jid.fromString(_str);
    return argument;
}

QDBusArgument &operator<<(QDBusArgument &argument, const Contact &contact)
{
    argument.beginStructure();
    StringDict attr = contact.getAttributes();
    argument << contact.getJid() << attr << contact.getGroups();
    argument.endStructure();
    return argument;
}
const QDBusArgument &operator>>(const QDBusArgument &argument, Contact &contact)
{
    argument.beginStructure();
    argument >> contact.getJid();
    StringDict attr;
    argument >> attr;
    contact.setAttributes(attr);
    argument >> contact.getGroups();
    argument.endStructure();
    return argument;
}

QDBusArgument &operator<<(QDBusArgument &argument, const MessageT &message)
{
    argument.beginStructure();
    argument << message.from_jid << message.text;
    argument.endStructure();
    return argument;
}

const QDBusArgument &operator>>(const QDBusArgument &argument, MessageT &message)
{
    argument.beginStructure();
    argument >> message.from_jid >> message.text;
    argument.endStructure();
    return argument;
}

QDBusArgument &operator<<(QDBusArgument &argument, const MenuT &menu)
{
    argument.beginStructure();
    argument << menu.category << menu.name << menu.type;
    argument.endStructure();
    return argument;
}

const QDBusArgument &operator>>(const QDBusArgument &argument, MenuT &menu)
{
    argument.beginStructure();
    argument >> menu.category >> menu.name >> menu.type;
    argument.endStructure();
    return argument;
}

QDBusArgument &operator<<(QDBusArgument &argument, const PresenceInfoT &presence_info)
{
    argument.beginStructure();
    argument << presence_info.show << presence_info.priority << presence_info.statuses;
    argument.endStructure();
    return argument;
}

const QDBusArgument &operator>>(const QDBusArgument &argument, PresenceInfoT &presence_info)
{
    argument.beginStructure();
    argument >> presence_info.show >> presence_info.priority >> presence_info.statuses;
    argument.endStructure();
    return argument;
}

