
/*
Bellaciao: a Salut à Toi frontend
Copyright (C) 2011  Jérôme Poisson (goffi@goffi.org)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef JID_H
#define JID_H

#include <QString>

class Jid {
    public:
        Jid();
        ~Jid();
        Jid(const QString& str);
        void fromString(const QString& str);
        QString getString() const;
        QString getBareString() const;
        QString getFullString() const;
        const QString& getUser() const;
        const QString& getDomain() const;
        const QString& getResource() const;
        void setUser(const QString& user);
        void setDomain(const QString& domain);
        void setResource(const QString& resource);
        const bool& isValid() const;
        Jid& operator=(const Jid& other);

    private:
        bool m_valid;
        QString m_user, m_domain, m_resource;
};

#endif

