/*
Bellaciao: a Salut à Toi frontend
Copyright (C) 2011  Jérôme Poisson (goffi@goffi.org)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "layout_widgets.h"
#include <QDebug>

WidgetProperty::WidgetProperty(const QString& name, const QString& tooltip)
    : m_name(name), m_type(NONE)
{
}

WidgetProperty::~WidgetProperty()
{
}

WidgetPropertyBool::WidgetPropertyBool(const QString& name, bool checked, const QString& tooltip)
    : WidgetProperty(name, tooltip), m_checked(checked), m_type(BOOL) 
{
}

LayoutWidget::LayoutWidget(const QString& name, const QString& icon)
    : m_name(name), m_icon(icon)
{
    qDebug() << "LayoutWidget constructeur (" << name <<")";

}

LayoutWidget::~LayoutWidget()
{
    qDebug() << "LayoutWidget destructeur";

}
